SystemOrganization addCategory: #GlueGun!
SystemOrganization addCategory: #'GlueGun-Tests'!

!Object methodsFor: '*GlueGun' stamp: 'HwaJong 10/25/2013 19:40'!
ifRespondsToThenPerform: aSymbol
	^(self respondsTo: aSymbol)
		ifTrue: [ self perform: aSymbol ]! !

!Object methodsFor: '*GlueGun' stamp: 'HwaJong 12/13/2013 16:52'!
ifRespondsToThenPerform: symbol1 elsePerform: symbol2
	^(self respondsTo: symbol1)
		ifTrue: [ self perform: symbol1 ]
		ifFalse: [ self perform: symbol2 ]! !

!Object methodsFor: '*GlueGun' stamp: 'HwaJong 12/13/2013 16:50'!
ifRespondsToThenPerform: symbol1 ifRespondsToThenPerform: symbol2
	^(self respondsTo: symbol1)
		ifTrue: [ self perform: symbol1 ]
		ifFalse: 
			[(self respondsTo: symbol2)
				ifTrue: [ self perform: symbol2 ]]! !

!Symbol methodsFor: '*GlueGun' stamp: 'HwaJong 10/25/2013 18:07'!
ifGlobalExist: aBlock ifGlobalNotExist: bBlock
	
	^Smalltalk classOrGlobalNamed: self ifExist: aBlock ifNotExist: bBlock! !

!Symbol methodsFor: '*GlueGun' stamp: 'HwaJong 10/25/2013 19:42'!
ifGlobalExistThenPerform: aSymbol
	^Smalltalk classOrGlobalNamed: self ifExist: [:cls| cls ifRespondsToThenPerform: aSymbol ] ifNotExist: [  ]! !

!SmalltalkImage methodsFor: '*GlueGun' stamp: 'HwaJong 10/25/2013 17:59'!
classOrGlobalNamed: aSymbol ifExist: aBlockClosure ifNotExist: aBlockClosure2
	^(self includesKey: aSymbol)
		ifTrue: [ aBlockClosure value: (self at: aSymbol) ]
		ifFalse: aBlockClosure2! !

!SmalltalkImage methodsFor: '*GlueGun' stamp: 'HwaJong 10/25/2013 18:00'!
ifGlobalExist: aSymbol do: aBlockClosure 
	^self classOrGlobalNamed: aSymbol ifExist: aBlockClosure ifNotExist: [ ]! !

!SmalltalkImage methodsFor: '*GlueGun' stamp: 'HwaJong 10/25/2013 19:58'!
ifGlobalExist: aSymbol do: aBlockClosure ifGlobalExist: aSymbol3 do: aBlockClosure4 
	^self 
		classOrGlobalNamed: aSymbol 
		ifExist: aBlockClosure 
		ifNotExist: 
			[self 
				classOrGlobalNamed: aSymbol3 
				ifExist: aBlockClosure4 
				ifNotExist: [ ] ]! !

TestCase subclass: #GlueGunMainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GlueGun-Tests'!

!GlueGunMainTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 19:47'!
testSmalltalkImageIfGlobalExistDo

	self assert: (Smalltalk ifGlobalExist: #Object do: [:cls| cls new hash ]) isInteger.
	self assert: (Smalltalk ifGlobalExist: #Objecttt do: [:cls| self fail. cls new hash ]) isNil.! !

!GlueGunMainTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 19:59'!
testSmalltalkImageIfGlobalExistDoIfGlobalExistDo

	self assert: (Smalltalk ifGlobalExist: #Processorrrr do: [:global| self fail ] ifGlobalExist: #Processor do: [:global| global highIOPriority ]) isInteger.
	self assert: (Smalltalk ifGlobalExist: #Processor do: [:global| global highIOPriority ] ifGlobalExist: #Processorrrr do: [:global| self fail ] ) isInteger.
	self assert: (Smalltalk ifGlobalExist: #Processorxxx do: [:global| global highIOPriority ] ifGlobalExist: #Processorrrr do: [:global| self fail ] ) isNil.! !

!GlueGunMainTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 19:54'!
testSymbolIfGlobalExistIfGlobalNotExist

	| got |
	got := #OrderedCollection ifGlobalExist: [:cls| cls withAll: 'abcd' ] ifGlobalNotExist: [ 'shit' ].
	self assert: (got isKindOf: OrderedCollection).
	self assert: got size = 4.
	
	got := #OrderedCollectionnnnn ifGlobalExist: [:cls| cls withAll: 'abcd' ] ifGlobalNotExist: [ 'shit' ].
	self assert: got equals: 'shit'! !

!GlueGunMainTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 19:55'!
testSymbolIfGlobalExistThenPerform

	self assert: (#String ifGlobalExistThenPerform: #new) equals: ''.
	self assert: (#String ifGlobalExistThenPerform: #youWouldNeverUnderstandThis) equals: nil.! !
